Copyright (c) 2004-2005 Advanced Micro Devices, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Copyright (c) 2008 Peter Pramberger

Trimmed and adapted for RedHat EL-3 kernel.

--- linux-2.4.24/arch/i386/config.in	2005-08-05 09:04:24.691553368 -0600
+++ linux-2.4.24.new/arch/i386/config.in	2005-08-05 09:02:15.000000000 -0600
@@ -42,6 +42,8 @@
 	 Winchip-C6				CONFIG_MWINCHIPC6 \
 	 Winchip-2				CONFIG_MWINCHIP2 \
 	 Winchip-2A/Winchip-3			CONFIG_MWINCHIP3D \
+	 Geode-GX/Castle			CONFIG_GEODE_GX \
+	 Geode-GX1/SC1200			CONFIG_GEODE_SC1200 \
 	 CyrixIII/VIA-C3			CONFIG_MCYRIXIII \
 	 VIA-C3-2				CONFIG_MVIAC3_2" Pentium-Pro
 #
@@ -139,9 +141,31 @@
    define_bool CONFIG_X86_GOOD_APIC y
    define_bool CONFIG_X86_USE_3DNOW y
    define_bool CONFIG_X86_PGE y
+   define_bool CONFIG_X86_USE_PPRO_CHECKSUM y 	
+   define_bool CONFIG_X86_F00F_WORKS_OK y
+fi
+
+if [ "$CONFIG_GEODE_SC1200" = "y" ]; then
+   define_int  CONFIG_X86_L1_CACHE_SHIFT 5
+   define_bool CONFIG_X86_USE_STRING_486 y
+   define_bool CONFIG_X86_ALIGNMENT_16 y
+   define_bool CONFIG_X86_HAS_TSC y
+   define_bool CONFIG_X86_PPRO_FENCE y
+   define_bool CONFIG_X86_F00F_WORKS_OK y
+fi
+
+if [ "$CONFIG_GEODE_GX" = "y" ]; then
+   define_int  CONFIG_X86_L1_CACHE_SHIFT 5
+   define_bool CONFIG_X86_HAS_TSC y
+   define_bool CONFIG_MTRR n
+   define_bool CONFIG_X86_LOCAL_APIC n
+   define_bool CONFIG_X86_GOOD_APIC n
+   define_bool CONFIG_X86_PGE y
    define_bool CONFIG_X86_USE_PPRO_CHECKSUM y
    define_bool CONFIG_X86_F00F_WORKS_OK y
+   define_bool CONFIG_X86_MCE n
 fi
+
 if [ "$CONFIG_MELAN" = "y" ]; then
    define_int  CONFIG_X86_L1_CACHE_SHIFT 4
    define_bool CONFIG_X86_USE_STRING_486 y
@@ -192,7 +216,9 @@
    define_bool CONFIG_X86_F00F_WORKS_OK y
 fi
 
+if [ "$CONFIG_GEODE_GX" != "y" ]; then
 bool 'Machine Check Exception' CONFIG_X86_MCE
+fi
 
 tristate 'Toshiba Laptop support' CONFIG_TOSHIBA
 tristate 'Dell laptop support' CONFIG_I8K
@@ -205,10 +231,19 @@
    tristate 'BIOS Enhanced Disk Drive calls determine boot disk (EXPERIMENTAL)' CONFIG_EDD
 fi
 
-choice 'High Memory Support' \
+# Geode GX does not have PAE support, so don't give em the option of 64G support
+
+if [ "$CONFIG_GEODE_GX" != "y" ]; then
+	choice 'High Memory Support' \
 	"off    CONFIG_NOHIGHMEM \
 	 4GB    CONFIG_HIGHMEM4G \
 	 64GB   CONFIG_HIGHMEM64G" off
+else
+	choice 'High Memory Support' \
+	"off	CONFIG_NOHIGHMEM \
+	 4GB	CONFIG_HIGHMEM4G" off
+fi
+
 if [ "$CONFIG_HIGHMEM4G" = "y" -o "$CONFIG_HIGHMEM64G" = "y" ]; then
    define_bool CONFIG_HIGHMEM y
 else
@@ -293,7 +293,11 @@
 fi
 
 bool 'Math emulation' CONFIG_MATH_EMULATION
+
+if [ "$CONFIG_GEODE_GX" != "y" ]; then
 bool 'MTRR (Memory Type Range Register) support' CONFIG_MTRR
+fi
+
 bool 'Symmetric multi-processing support' CONFIG_SMP
 
 
@@ -309,13 +313,15 @@
 fi
 
 if [ "$CONFIG_SMP" != "y" ]; then
-   bool 'Local APIC support on uniprocessors' CONFIG_X86_UP_APIC
-   dep_bool 'IO-APIC support on uniprocessors' CONFIG_X86_UP_IOAPIC $CONFIG_X86_UP_APIC
-   if [ "$CONFIG_X86_UP_APIC" = "y" ]; then
-      define_bool CONFIG_X86_LOCAL_APIC y
-   fi
-   if [ "$CONFIG_X86_UP_IOAPIC" = "y" ]; then
-      define_bool CONFIG_X86_IO_APIC y
+   if [ "$CONFIG_GEODE_GX" != "y" ]; then
+      bool 'Local APIC support on uniprocessors' CONFIG_X86_UP_APIC
+      dep_bool 'IO-APIC support on uniprocessors' CONFIG_X86_UP_IOAPIC $CONFIG_X86_UP_APIC
+      if [ "$CONFIG_X86_UP_APIC" = "y" ]; then
+         define_bool CONFIG_X86_LOCAL_APIC y
+      fi
+      if [ "$CONFIG_X86_UP_IOAPIC" = "y" ]; then
+         define_bool CONFIG_X86_IO_APIC y
+      fi
    fi
 else
    bool 'Clustered APIC support' CONFIG_X86_CLUSTERED_APIC
--- linux-2.4.24/arch/i386/kernel/setup.c	2005-08-05 09:04:24.694552912 -0600
+++ linux-2.4.24.new/arch/i386/kernel/setup.c	2005-08-05 09:02:15.000000000 -0600
@@ -74,6 +74,9 @@
  *  Provisions for empty E820 memory regions (reported by certain BIOSes).
  *  Alex Achenbach <xela@slit.de>, December 2002.
  *
+ *  AMD Geode support by Lycoris Solutions Team and NSC Longmont.
+ *  solutions@lycoris.com, john.zulauf@amd.com.  December 2003.
+ *
  */
 
 /*
@@ -1514,6 +1517,113 @@
 	return r;
 }
 
+#ifdef CONFIG_GEODE_GX
+
+/* The CS5535 companion chip has two UARTs.  This code enables the second
+   UART so other devices can use it.  We do it here so we can expose the
+   port early enough for serial debugging 
+*/
+
+/* Note - this does not check to see if the CS5535 actually exists */
+
+#define LO(b)  (((1 << b) << 16) | 0x0000)
+#define HI(b)  ((0x0000 << 16) | (1 << b))
+
+static u32 outtab[16] __initdata = 
+{ 
+	0x00,HI(4), 0x04,HI(4), 0x08,HI(4),
+	0x0c,LO(4), 0x10,HI(4), 0x14,LO(4),
+	0x18,LO(4), 0x1C,LO(4) 
+};
+
+static u32 intab[16] __initdata = {
+	0x20,HI(3), 0x24,LO(3), 0x28,LO(3),
+	0x2C,LO(3), 0x34,HI(3), 0x38,LO(3),
+     0x40,LO(3), 0x44,LO(3)
+};
+
+static int __init init_cs5535_uart2(char *str) 
+{
+	u32 lo = 0, hi = 0;
+	u32 base; u32 i;
+	
+	/* Enable UART2 instead of DDC */
+	
+	rdmsr(0x51400014, lo, hi);
+	lo &= 0xFF8FFFFF;
+	lo |= 0x00500000;   /* 0x2F8 ttyS1 */
+	wrmsr(0x51400014, lo, hi);
+	   
+	/* Set up the UART registers */
+	wrmsr(0x5140003E, 0x12, 0x00);
+	
+	rdmsr(0x5140000C, lo, hi); 
+	base = (u32)(lo & 0xFF00); 
+	
+	/* Enable the GPIO pins (in and out) */
+	
+	for(i = 0; i < 16; i += 2) {
+		outl(outtab[i + 1], base + outtab[i]);
+		outl(intab[i + 1], base + intab[i]);
+	}
+	
+	/* Enable the IRQ */
+	
+	rdmsr(0x51400021,lo,hi);
+	lo &= 0x0FFFFFFF;
+	lo |= 0x30000000; /* IRQ 3 */
+	wrmsr(0x51400021,lo,hi);
+}
+
+__setup("geodeuart2", init_cs5535_uart2);
+
+#endif
+
+static int __init init_amd_geode(struct cpuinfo_x86 *c)
+{
+	int r;
+
+	/* Bit 31 in normal CPUID used for nonstandard 3DNow ID;
+	   3DNow is IDd by bit 31 in extended CPUID (1*32+31) anyway */
+	clear_bit(0*32+31, &c->x86_capability);
+	
+	r = get_model_name(c);
+
+	switch(c->x86_model)
+	{
+	        case 4: /* GX1/SCxx00 */
+
+			/* GX1 uses bits 16 and 24 differently - 
+			   you could probably just do 
+
+			   clear_bit(0*32+16, &c->x86_capability);
+			   clear_bit(0*32+24, &c->x86_capability);
+
+			   since I don't think the kernel supports
+			   FPU-CMOV or Cyrix MMX.  Unsure tho.
+
+			   Also checking GX1 cache here needs to be done -
+			   display_cacheinfo() won't work according to
+			   AMD specs.
+			*/
+
+			break;
+
+		case 5: /* GX */
+			display_cacheinfo(c);
+			break;
+			
+	        case 10: /* Geode ??? model=10 */
+			/* What else needs to happen here? */
+			display_cacheinfo(c);
+			break;
+			
+
+	}
+
+	return r;
+}
+
 /*
  * Read NSC/Cyrix DEVID registers (DIR) to get more detailed info. about the CPU
  */
@@ -2871,11 +2981,24 @@
 		break;
 
 	case X86_VENDOR_NSC:
-	        init_cyrix(c);
+             /* NSC chips with TFMS of 0x54n or 0x55n are Geode 
+		- do a special init */
+		if ( (c->x86 == 5) &&
+		     (c->x86_model >= 4 && c->x86_model <= 5))
+			init_amd_geode(c);
+		else
+		        init_cyrix(c);
 		break;
 
 	case X86_VENDOR_AMD:
-		init_amd(c);
+		/* Unlike its predecessors, the Castle flavor of the 
+		   Geode family declares itself as an AuthenticAMD,
+		   so check for that here */
+		
+		if (c->x86 == 5 && c->x86_model == 10)
+			init_amd_geode(c);
+		else
+			init_amd(c);
 		break;
 
 	case X86_VENDOR_CENTAUR:
--- linux-2.4.24/drivers/ide/pci/Makefile	2005-08-05 09:04:24.810535280 -0600
+++ linux-2.4.24.new/drivers/ide/pci/Makefile	2005-08-05 09:02:27.000000000 -0600
@@ -11,6 +11,7 @@
 obj-$(CONFIG_BLK_DEV_CMD640)		+= cmd640.o
 obj-$(CONFIG_BLK_DEV_CMD64X)		+= cmd64x.o
 obj-$(CONFIG_BLK_DEV_CS5530)		+= cs5530.o
+obj-$(CONFIG_BLK_DEV_CS5535)        += cs5535.o
 obj-$(CONFIG_BLK_DEV_CY82C693)		+= cy82c693.o
 obj-$(CONFIG_BLK_DEV_HPT34X)		+= hpt34x.o
 obj-$(CONFIG_BLK_DEV_HPT366)		+= hpt366.o
--- linux-2.4.24/drivers/ide/pci/cs5535.c	1969-12-31 17:00:00.000000000 -0700
+++ linux-2.4.24.new/drivers/ide/pci/cs5535.c	2005-08-05 09:02:27.000000000 -0600
@@ -0,0 +1,387 @@
+/* <LIC_AMD_STD>
+ * Copyright (c) 2004-2005 Advanced Micro Devices, Inc.
+ * 
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * 
+ * The full GNU General Public License is included in this distribution in the
+ * file called COPYING
+ * </LIC_AMD_STD>  */
+/* <CTL_AMD_STD>
+ * </CTL_AMD_STD>  */
+/* <DOC_AMD_STD>
+ *  CS5535 documentation available from AMD.
+ * </DOC_AMD_STD>  */
+
+#include <linux/config.h>
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/delay.h>
+#include <linux/timer.h>
+#include <linux/mm.h>
+#include <linux/ioport.h>
+#include <linux/blkdev.h>
+#include <linux/hdreg.h>
+#include <linux/interrupt.h>
+#include <linux/pci.h>
+#include <linux/init.h>
+#include <linux/ide.h>
+#include <asm/io.h>
+#include <asm/irq.h>
+#include <asm/msr.h>
+
+#include "ide-timing.h"
+#include "ide_modes.h"
+#include "cs5535.h"
+
+#if defined(DISPLAY_CS5535_TIMINGS) && defined(CONFIG_PROC_FS)
+#include <linux/stat.h>
+#include <linux/proc_fs.h>
+
+static u8 cs5535_proc = 0;
+static struct pci_dev *bmide_dev;
+static u8 w80 = 0;
+
+static int cs5535_get_info (char *buffer, char **addr, off_t offset, int count)
+{
+	char *p = buffer;
+	unsigned long bibma = pci_resource_start(bmide_dev, 4);
+
+	u8  c0 = 0;
+
+	/*
+	 * at that point bibma+0x2 et bibma+0xa are byte registers
+	 * to investigate:
+	 */
+
+	c0 = inb_p((u16)bibma + 0x02);
+
+	p += sprintf(p, "\n                                "
+		     "AMD/NS 5535 Chipset.\n");
+
+	p += sprintf(p, "--------------- drive0 --------- drive1 ------\n");
+	p += sprintf(p, "DMA enabled:    %s              %s\n",(c0&0x20) ? "yes" : "no ",
+		     (c0&0x40) ? "yes" : "no ");
+
+	pci_read_config_byte(bmide_dev, CS5535_CABLE_DETECT, &c0);
+
+	p += sprintf(p, "80 Wire Cable:  %s              %s\n", (c0 & 1) ? "yes" : "no", 
+		     (c0 & 2) ? "yes" :  "no");
+	
+	return p-buffer;
+}
+
+#endif /* DISPLAY_CS5535_TIMINGS && CONFIG_PROC_FS */
+  
+/* Format I PIO settings. We seperate out cmd and data for safer timings */
+
+static unsigned int cs5535_pio_cmd_timings[5] = 
+{ 0xF7F4, 0x53F3, 0x13F1, 0x5131, 0x1131 };
+static unsigned int cs5535_pio_dta_timings[5] = 
+{ 0xF7F4, 0xF173, 0x8141, 0x5131, 0x1131 };
+
+static unsigned int cs5535_mwdma_timings[3] = 
+{ 0x7F0FFFF3, 0x7F035352, 0x7f024241 };
+
+static unsigned int cs5535_udma_timings[5] = 
+{ 0x7F7436A1, 0x7F733481, 0x7F723261, 0x7F713161, 0x7F703061 };
+
+/* Macros to check if the register is the reset value -  reset value is an
+   invalid timing and indicates the register has not been set previously */
+
+#define CS5535_BAD_PIO(timings) ( (timings&~0x80000000)==0x00009172 )
+#define CS5535_BAD_DMA(timings) ( (timings & 0x000FFFFF) == 0x00077771 )
+
+#define DEFAULT_PIO   ( (cs5535_pio_cmd_timings[0] << 16) | cs5535_pio_dta_timings[0] )
+
+static u8 cs5535_get_dma_speed(u32 timings) {
+	int i;
+
+	for(i = 0; i < 3; i++) 
+		if (cs5535_mwdma_timings[i] == timings)
+			return  XFER_MW_DMA_0 + i;
+	
+	for(i = 0; i < 5; i++)
+		if (cs5535_udma_timings[i] == timings)
+			return XFER_UDMA_0 + i;
+
+	return -1;
+}
+	
+static u8 cs5535_get_pio_mode(int unit) {
+
+	u32 reg, dummy;
+	int i;
+
+	rdmsr(unit ? ATAC_CH0D1_PIO : ATAC_CH0D0_PIO, reg, dummy);
+	
+	for(i = 0; i < 5; i++) {
+		if ((reg & 0xFFFF) == cs5535_pio_dta_timings[i])
+			return i;
+	}
+
+	BUG();
+	return 0;
+}
+
+static void cs5535_set_speed(ide_drive_t *drive, u8 speed)  {
+
+	u32 reg, dummy;
+	int unit = drive->select.b.unit;
+
+	if ((speed & XFER_MODE) == XFER_PIO) {
+		u8 data1 = speed - XFER_PIO_0;
+		u8 data2 = cs5535_get_pio_mode(!unit);
+
+		u8 cmd = (data1 < data2) ? data1 : data2;
+
+		/* Write the other drive timings */
+		reg = (cs5535_pio_cmd_timings[cmd] << 16) | cs5535_pio_dta_timings[data2];
+		wrmsr(!unit ? ATAC_CH0D1_PIO : ATAC_CH0D0_PIO, reg, 0);
+
+		/* Write our drive timings*/
+		reg = (cs5535_pio_cmd_timings[cmd] << 16) | cs5535_pio_dta_timings[data1];
+		wrmsr(unit ? ATAC_CH0D1_PIO : ATAC_CH0D0_PIO, reg, 0);
+
+		/* Write the Format 1 bit in the DMA register */
+		rdmsr(unit ? ATAC_CH0D1_DMA : ATAC_CH0D0_DMA, reg, dummy);    
+		wrmsr(unit ? ATAC_CH0D1_DMA : ATAC_CH0D0_DMA, reg | 0x80000000, 0);
+	}
+	else {
+		rdmsr(unit ? ATAC_CH0D1_DMA : ATAC_CH0D0_DMA, reg, dummy);
+		
+		
+		if (speed >= XFER_UDMA_0 && speed <= XFER_UDMA_7) 
+			reg = (reg & 0x80000000) | cs5535_udma_timings[speed - XFER_UDMA_0];
+		else if (speed >= XFER_MW_DMA_0 && speed <= XFER_MW_DMA_2) 
+			reg = (reg & 0x80000000) | cs5535_mwdma_timings[speed - XFER_MW_DMA_0];
+		else 
+			return;
+
+		wrmsr(unit ? ATAC_CH0D1_DMA : ATAC_CH0D0_DMA, reg, 0);
+	}
+}
+
+static int cs5535_set_drive(ide_drive_t *drive, u8 speed) 
+{       
+	if (speed != drive->current_speed)
+		ide_config_drive_speed(drive, speed);
+	
+	cs5535_set_speed(drive, speed);	
+	drive->current_speed = speed;
+	return 0;
+}
+
+
+static void cs5535_tuneproc (ide_drive_t *drive,u8 pio) 
+{ 	
+	u8 speed = 0;
+
+ 	if (pio == 255)
+		speed = ide_find_best_mode(drive, XFER_PIO | XFER_EPIO);
+	else if (pio < 100) 
+		speed = XFER_PIO_0 + min_t(byte, pio, 5);
+	else if (pio < 200)
+		speed = XFER_MW_DMA_0 + min_t(byte, (pio - 100), 2);
+	else 
+		speed = XFER_UDMA_0 + min_t(byte, (pio - 200), 7);
+			
+	cs5535_set_drive(drive, speed);
+}
+
+static int cs5535_config_dma(ide_drive_t *drive) {
+
+	u8 speed = 0;
+	unsigned long map = XFER_MWDMA | XFER_UDMA;
+	if (w80) map |= XFER_UDMA_66;
+
+	/* Get the best mode for this drive */
+	speed = ide_find_best_mode(drive, map);
+		
+	if ((speed & XFER_MODE) != XFER_PIO) {
+		cs5535_set_drive(drive, speed);
+		
+		if (drive->autodma)
+			return HWIF(drive)->ide_dma_on(drive);
+	}
+	
+	return 
+		HWIF(drive)->ide_dma_off_quietly(drive);
+}
+	
+static unsigned int __init init_chipset_cs5535 (struct pci_dev *dev, const char *name)
+{
+	unsigned long flags;
+	u8 bit;
+
+#if defined(DISPLAY_CS5535_TIMINGS) && defined(CONFIG_PROC_FS)
+	if (!cs5535_proc)
+	{
+		cs5535_proc = 1;
+		bmide_dev = dev;
+		ide_pci_register_host_proc(&cs5535_procs[0]);
+	}
+#endif /* DISPLAY_CS5535_TIMINGS && CONFIG_PROC_FS */
+
+	pci_read_config_byte(bmide_dev, CS5535_CABLE_DETECT, &bit);
+	w80 = bit & 1;  /* Remember if we have a 80 wire cable */
+
+	return 0;
+}
+
+static void __init init_hwif_cs5535 (ide_hwif_t *hwif)
+{
+unsigned long dummy;
+u32           timings;
+unsigned long dfltpio;
+unsigned long bibma;
+int           dmastatus;
+
+	hwif->autodma = 0;
+	dfltpio = (cs5535_pio_cmd_timings[0] << 16) | 
+	cs5535_pio_dta_timings[0];
+	dmastatus = 0;
+
+	if (!bmide_dev)
+		return;
+	else
+    	{
+		bibma = pci_resource_start(bmide_dev, 4);
+		dmastatus = inb_p((u16) bibma + 0x02);		
+	}
+
+	if (hwif->mate)
+		hwif->serialized = hwif->mate->serialized = 1;
+
+	hwif->tuneproc = &cs5535_tuneproc;
+	hwif->speedproc = &cs5535_set_drive;
+
+	/* Check the registers, and set up the PIO registers if nessesary */
+	/* Note that this will default to whatever the BIOS set them to be */
+
+	/* Drive 0 */
+
+ 	rdmsr(ATAC_CH0D0_PIO,timings,dummy);
+	if (CS5535_BAD_PIO(timings)) 
+	{
+	 	/* PIO timings not initialized? */
+		wrmsr(ATAC_CH0D0_PIO, dfltpio, 0);
+
+		if(!hwif->drives[0].autotune)
+			hwif->drives[0].autotune = 1;
+	}
+
+	/* Drive 1 */
+
+	rdmsr(ATAC_CH0D1_PIO,timings,dummy);
+	if (CS5535_BAD_PIO(timings)) 
+	{
+		/* PIO timings not initialized? */
+		wrmsr(ATAC_CH0D1_PIO,dfltpio,0);
+		if(!hwif->drives[1].autotune)
+			hwif->drives[1].autotune = 1;
+
+	}
+
+	/* We want to take special care not to mess with the settings
+	   from the BIOS.  If the DMA registers are already set, just
+	   assume those are correct, and go from there */
+
+ 	rdmsr(ATAC_CH0D0_DMA, timings, dummy);
+
+	if (!CS5535_BAD_DMA(timings)) {
+		if (dmastatus & 0x20)
+			hwif->ide_dma_on(&(hwif->drives[0]));
+
+		hwif->drives[0].autotune = 2; 
+	}
+	
+	rdmsr(ATAC_CH0D1_DMA, timings, dummy);
+
+	if (!CS5535_BAD_DMA(timings)) {
+		if (dmastatus & 0x40)
+			hwif->ide_dma_on(&(hwif->drives[1]));
+
+		hwif->drives[1].autotune = 2;
+	}
+
+	hwif->atapi_dma = 1;
+    
+	hwif->ultra_mask = 0x1F;
+	hwif->mwdma_mask = 0x07;
+
+	/* w80 will be 1 if a 80 wire cable was detected */
+
+	hwif->udma_four = w80;
+
+	hwif->ide_dma_check = &cs5535_config_dma;
+	if (!noautodma) hwif->autodma = 1;
+		
+	hwif->drives[0].autodma = hwif->autodma;
+	hwif->drives[1].autodma = hwif->autodma;
+}
+
+extern void ide_setup_pci_device(struct pci_dev *, ide_pci_device_t *);
+static int __devinit cs5535_init_one(struct pci_dev *dev, const struct pci_device_id *id)
+{
+	ide_pci_device_t *d = &cs5535_chipsets[id->driver_data];
+
+	if (dev->device != d->device) BUG();
+
+	ide_setup_pci_device(dev, d);
+	MOD_INC_USE_COUNT;
+	return 0;
+}
+
+/* NOTE:  This is not for customer release - this provides support for
+   the Hiddensee A0 IDE device. 
+*/
+
+#ifndef PCI_DEVICE_ID_AMD_CS5536_A0IDE  
+#define PCI_DEVICE_ID_AMD_CS5536_A0IDE    0x2092
+#endif
+
+static struct pci_device_id cs5535_pci_tbl[] __devinitdata = 
+{
+	{ PCI_VENDOR_ID_NS, PCI_DEVICE_ID_NS_CS5535_IDE, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 0},
+	{ PCI_VENDOR_ID_AMD, PCI_DEVICE_ID_AMD_CS5536_A0IDE, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 1},
+	{ 0, },
+};
+
+static struct pci_driver driver = {
+	.name       = "CS5535/6 IDE",
+	.id_table   = cs5535_pci_tbl,
+	.probe      = cs5535_init_one,
+};
+
+
+static int cs5535_ide_init(void)
+{
+	return ide_pci_register_driver(&driver);
+}
+
+static void cs5535_ide_exit(void)
+{
+	ide_pci_unregister_driver(&driver);
+}
+
+module_init(cs5535_ide_init);
+module_exit(cs5535_ide_exit);
+
+MODULE_AUTHOR("AMD");
+MODULE_DESCRIPTION("PCI driver module for AMD CS5535/6 IDE");
+MODULE_LICENSE("GPL");
+
+EXPORT_NO_SYMBOLS;
--- linux-2.4.24/drivers/ide/pci/cs5535.h	1969-12-31 17:00:00.000000000 -0700
+++ linux-2.4.24.new/drivers/ide/pci/cs5535.h	2005-08-05 09:02:27.000000000 -0600
@@ -0,0 +1,110 @@
+/* <LIC_AMD_STD>
+ * Copyright (c) 2004-2005 Advanced Micro Devices, Inc.
+ * 
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * 
+ * The full GNU General Public License is included in this distribution in the
+ * file called COPYING
+ * </LIC_AMD_STD>  */
+/* <CTL_AMD_STD>
+ * </CTL_AMD_STD>  */
+/* <DOC_AMD_STD>
+ * </DOC_AMD_STD>  */
+
+#ifndef CS5535_H
+#define CS5535_H
+
+#include <linux/config.h>
+#include <linux/pci.h>
+#include <linux/ide.h>
+
+#define DISPLAY_CS5535_TIMINGS
+
+#define MSR_ATAC_BASE    0x51300000
+#define ATAC_GLD_MSR_CAP (MSR_ATAC_BASE+0)
+#define ATAC_GLD_MSR_CONFIG    (MSR_ATAC_BASE+0x01)
+#define ATAC_GLD_MSR_SMI       (MSR_ATAC_BASE+0x02)
+#define ATAC_GLD_MSR_ERROR     (MSR_ATAC_BASE+0x03)
+#define ATAC_GLD_MSR_PM        (MSR_ATAC_BASE+0x04)
+#define ATAC_GLD_MSR_DIAG      (MSR_ATAC_BASE+0x05)
+#define ATAC_IO_BAR            (MSR_ATAC_BASE+0x08)
+#define ATAC_RESET             (MSR_ATAC_BASE+0x10)
+#define ATAC_CH0D0_PIO         (MSR_ATAC_BASE+0x20)
+#define ATAC_CH0D0_DMA         (MSR_ATAC_BASE+0x21)
+#define ATAC_CH0D1_PIO         (MSR_ATAC_BASE+0x22)
+#define ATAC_CH0D1_DMA         (MSR_ATAC_BASE+0x23) 
+#define ATAC_PCI_ABRTERR       (MSR_ATAC_BASE+0x24)
+#define ATAC_BM0_CMD_PRIM      0x00
+#define ATAC_BM0_STS_PRIM      0x02
+#define ATAC_BM0_PRD           0x04
+
+#define CS5535_CABLE_DETECT    0x48
+
+#if defined(DISPLAY_CS5535_TIMINGS) && defined(CONFIG_PROC_FS)
+#include <linux/stat.h>
+#include <linux/proc_fs.h>
+
+static u8 cs5535_proc;
+
+static int cs5535_get_info(char *, char **, off_t, int);
+
+static ide_pci_host_proc_t cs5535_procs[] __initdata = {
+	{
+		.name		= "cs5535",
+		.set		= 1,
+		.get_info	= cs5535_get_info,
+		.parent		= NULL,
+	},
+};
+
+#endif /* DISPLAY_CS5530_TIMINGS && CONFIG_PROC_FS */
+
+static unsigned int init_chipset_cs5535(struct pci_dev *, const char *);
+static void init_hwif_cs5535(ide_hwif_t *);
+
+static ide_pci_device_t cs5535_chipsets[] __devinitdata = {
+	{	/* 0 */
+		.vendor		= PCI_VENDOR_ID_NS,
+		.device		= PCI_DEVICE_ID_NS_CS5535_IDE,
+		.name		= "CS5535",
+		.init_chipset	= init_chipset_cs5535,
+		.init_iops	= NULL,
+		.init_hwif	= init_hwif_cs5535,
+		.channels	= 1,
+		.autodma	= AUTODMA,
+		.enablebits	= { {0x00,0x00,0x00} },  
+		.bootable	= ON_BOARD,
+		.extra		= 0,
+	},{	/* 1 */
+		.vendor		= PCI_VENDOR_ID_AMD,
+		.device		= PCI_DEVICE_ID_AMD_CS5536_IDE,
+		.name		= "CS5536",
+		.init_chipset	= init_chipset_cs5535,
+		.init_iops	= NULL,
+		.init_hwif	= init_hwif_cs5535,
+		.channels	= 1,
+		.autodma	= AUTODMA,
+		.enablebits	= { {0x00,0x00,0x00} },  
+		.bootable	= ON_BOARD,
+		.extra		= 0,
+	},{
+		.vendor		= 0,
+		.device		= 0,
+		.channels	= 0,
+		.bootable	= EOL,
+	}
+};
+
+#endif /* CS5535_H */
--- linux-2.4.24/drivers/ide/pci/amd74xx.c	2005-08-05 09:04:24.816534368 -0600
+++ linux-2.4.24.new/drivers/ide/pci/amd74xx.c	2005-08-05 09:02:27.000000000 -0600
@@ -59,6 +59,6 @@
 	{ PCI_DEVICE_ID_NVIDIA_NFORCE3S_SATA2, 0x00, 0x50, AMD_UDMA_100 },              /* NVIDIA nForce3s SATA2 */
 	{ PCI_DEVICE_ID_NVIDIA_NFORCE_CK804_IDE, 0x00, 0x50, AMD_UDMA_133 },
-	/* NVIDIA CK804 */
+	{ PCI_DEVICE_ID_AMD_CS5536_IDE,  0x00, 0x40, AMD_UDMA_100 },			/* AMD Hiddensee */    
 
 	{ 0 }
 };
@@ -452,6 +452,7 @@
 	{ PCI_VENDOR_ID_NVIDIA, PCI_DEVICE_ID_NVIDIA_NFORCE3S_SATA, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 11},
 	{ PCI_VENDOR_ID_NVIDIA, PCI_DEVICE_ID_NVIDIA_NFORCE3S_SATA2, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 12},
 	{ PCI_VENDOR_ID_NVIDIA, PCI_DEVICE_ID_NVIDIA_NFORCE_CK804_IDE, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 13},
+	{ PCI_VENDOR_ID_AMD,	PCI_DEVICE_ID_AMD_CS5536_IDE, PCI_ANY_ID, PCI_ANY_ID, 0, 0, 14},

 	{ 0, },
 };
--- linux-2.4.24/drivers/ide/pci/amd74xx.h	2005-08-05 09:04:24.817534216 -0600
+++ linux-2.4.24.new/drivers/ide/pci/amd74xx.h	2005-08-05 09:02:27.000000000 -0600
@@ -95,7 +95,21 @@
 		.device		= 0,
 		.channels	= 0,
 		.bootable	= EOL,
+	},
+	{	/* 14 */
+		.vendor		= PCI_VENDOR_ID_AMD,
+		.device		= PCI_DEVICE_ID_AMD_CS5536_IDE,
+		.name		= "AMD5536",
+		.init_chipset	= init_chipset_amd74xx,
+		.init_iops	= NULL,
+		.init_hwif	= init_hwif_amd74xx,
+		.init_dma	= init_dma_amd74xx,
+		.autodma	= AUTODMA,
+		.channels	= 1,
+		.enablebits	= {{0x40,0x02,0x02}},
+		.bootable	= ON_BOARD,
+		.extra		= 0
 	}
 };
 
 #endif /* AMD74XX_H */
--- linux-2.4.24/drivers/ide/Config.in	2005-08-05 09:04:24.821533608 -0600
+++ linux-2.4.24.new/drivers/ide/Config.in	2005-08-05 09:02:27.000000000 -0600
@@ -53,6 +53,7 @@
 	    dep_tristate '    Compaq Triflex IDE support' CONFIG_BLK_DEV_TRIFLEX $CONFIG_BLK_DEV_IDEDMA_PCI
 	    dep_tristate '    CY82C693 chipset support' CONFIG_BLK_DEV_CY82C693 $CONFIG_BLK_DEV_IDEDMA_PCI
 	    dep_tristate '    Cyrix CS5530 MediaGX chipset support' CONFIG_BLK_DEV_CS5530 $CONFIG_BLK_DEV_IDEDMA_PCI
+	    dep_tristate '    AMD CS553{5|6A0} chipset support' CONFIG_BLK_DEV_CS5535 $CONFIG_BLK_DEV_IDEDMA_PCI   
   	    dep_tristate '    HPT34X chipset support' CONFIG_BLK_DEV_HPT34X $CONFIG_BLK_DEV_IDEDMA_PCI
 	    dep_mbool    '      HPT34X AUTODMA support (WIP)' CONFIG_HPT34X_AUTODMA $CONFIG_BLK_DEV_HPT34X $CONFIG_IDEDMA_PCI_WIP
 	    dep_tristate '    HPT36X/37X chipset support' CONFIG_BLK_DEV_HPT366 $CONFIG_BLK_DEV_IDEDMA_PCI
+module_exit (cleanup);
--- linux-2.4.24/drivers/char/hw_random.c	2005-08-05 09:04:25.052498496 -0600
+++ linux-2.4.24.new/drivers/char/hw_random.c	2005-08-05 09:02:25.000000000 -0600
@@ -1,4 +1,10 @@
 /*
+        Added support for the AMD Geode Castle RNG 
+	(c) Copyright 2004 Advanced Micro Devices, Inc.  
+	<jordan.crouse@amd.com>
+
+	derived from
+
  	Hardware driver for the Intel/AMD/VIA Random Number Generators (RNG)
 	(c) Copyright 2003 Red Hat Inc <jgarzik@redhat.com>
  
@@ -97,6 +103,11 @@
 static unsigned int via_data_present (void);
 static u32 via_data_read (void);
 
+static int __init geode_init(struct pci_dev *dev);
+static void geode_cleanup(void);
+static unsigned int geode_data_present (void);
+static u32 geode_data_read (void);
+
 struct rng_operations {
 	int (*init) (struct pci_dev *dev);
 	void (*cleanup) (void);
@@ -124,6 +135,9 @@
 	rng_hw_intel,
 	rng_hw_amd,
 	rng_hw_via,
+#ifdef CONFIG_GEODE_GX
+	rng_hw_geode,
+#endif
 };
 
 static struct rng_operations rng_vendor_ops[] = {
@@ -139,6 +153,11 @@
 
 	/* rng_hw_via */
 	{ via_init, via_cleanup, via_data_present, via_data_read, 1 },
+
+#ifdef CONFIG_GEODE_GX
+	/* rng_hw_geode */
+	{ geode_init, geode_cleanup, geode_data_present, geode_data_read, 4 }
+#endif
 };
 
 /*
@@ -159,6 +178,10 @@
 	{ 0x8086, 0x244e, PCI_ANY_ID, PCI_ANY_ID, 0, 0, rng_hw_intel },
 	{ 0x8086, 0x245e, PCI_ANY_ID, PCI_ANY_ID, 0, 0, rng_hw_intel },
 
+#ifdef CONFIG_GEODE_GX
+	{ PCI_VENDOR_ID_AMD, PCI_DEVICE_ID_AMD_CASTLE_AES,
+	  PCI_ANY_ID, PCI_ANY_ID, 0, 0, rng_hw_geode },
+#endif
 	{ 0, },	/* terminate list */
 };
 MODULE_DEVICE_TABLE (pci, rng_pci_tbl);
@@ -461,7 +484,56 @@
 	wrmsr(MSR_VIA_RNG, lo, hi);
 }
 
+#ifdef CONFIG_GEODE_GX
+
+/***********************************************************************
+ *
+ * AMD Geode RNG operations
+ *
+ */
+
+static void *geode_rng_base = 0x0; /* The device is actually the AES device,
+				     the RNG lives at 0x50 and 0x54 thereof */
+
+#define GEODE_RNG_DATA_REG   0x50
+#define GEODE_RNG_STATUS_REG 0x54
+
+static u32 geode_data_read(void) {
+	u32 val;
+
+	val = *((int *) (geode_rng_base + GEODE_RNG_DATA_REG));
+	return val;
+}
+
+static unsigned int geode_data_present(void) {
+	u32 val;
+
+	val = *((int *) (geode_rng_base + GEODE_RNG_STATUS_REG));
+	return val;
+}
+
+static void geode_cleanup(void) {
+	iounmap(geode_rng_base);
+  	geode_rng_base = 0x0;
+}
+
+static int geode_init(struct pci_dev *dev) {		
+	u32 rng_base = pci_resource_start(dev, 0);
+	if (!rng_base) return 1;
 
+	geode_rng_base = ioremap(rng_base, 0x58);
+
+	if (geode_rng_base == NULL) {
+		printk(KERN_ERR PFX "Cannot ioremap RNG memory\n");
+		return -EBUSY;
+	}
+
+	printk(KERN_INFO PFX "Geode RNG registers at %p\n", geode_rng_base);
+	return 0;
+}
+
+#endif
+       
 /***********************************************************************
  *
  * /dev/hwrandom character device handling (major 10, minor 183)
@@ -578,7 +650,7 @@
 
 	DPRINTK ("ENTER\n");
 
-	/* Probe for Intel, AMD RNGs */
+	/* Probe for Intel, AMD, Geode RNGs */
 	while ((pdev = pci_find_device(PCI_ANY_ID, PCI_ANY_ID, pdev)) != NULL) {
 		ent = pci_match_device (rng_pci_tbl, pdev);
 		if (ent) {
--- linux-2.4.24/Documentation/geode.txt	1969-12-31 17:00:00.000000000 -0700
+++ linux-2.4.24.new/Documentation/geode.txt	2005-08-05 09:02:15.000000000 -0600
@@ -0,0 +1,12 @@
+Running Linux on the AMD Geode Architecture
+=======================================
+
+Configuration Options
+
+The following options enable various Geode and CS5535 features:
+
+CONFIG_GEODE_GX - Enable GX and LX processor support
+CONFIG_BLK_DEV_CS5535 - Enable IDE support on the CS5535 companion chip
+CONFIG_USB_OHCI - Enable USB support on the CS5535 companion chip
+
+
--- linux-2.4.24/Documentation/Configure.help	2005-08-05 09:04:25.341454568 -0600
+++ linux-2.4.24.new/Documentation/Configure.help	2005-08-05 09:02:14.000000000 -0600
@@ -239,6 +239,12 @@
   network and embedded applications.  For more information see the
   Axis Communication site, <http://developer.axis.com/>.
 
+AMD Geode GX and Castle processors
+CONFIG_GEODE_GX
+  The AMD Geode GX and Castle processors are low power X86 processors targeted
+  for embedded and multimedia applications.  The Geode Linux team has a home
+  page at
+
 Unsynced TSC support
 CONFIG_X86_TSC_DISABLE
   This option is used for getting Linux to run on a NUMA multi-node 
@@ -1172,9 +1178,16 @@
   Include support for UDMA on the Cyrix MediaGX 5530 chipset. This
   will automatically be detected and configured if found.
 
-  It is safe to say Y to this question.
+  It is safe to say Y to this question.
+  People with SCSI-only systems should say N here.  If in doubt, say Y.
+
+AMD CS5535/CS5536A0 Chipset support
+CONFIG_CS5535
+   Include support for UDMA on the AMD CS5535 and CS5536A0 chipsets.  This will 
+   automatically be detected and configured if found.
 
-  People with SCSI-only systems should say N here. If unsure, say Y.
+  It is safe to say Y to this question.
+  People with SCSI-only systems should say N here.  If in doubt, say Y.
 
 HPT34X chipset support
 CONFIG_BLK_DEV_HPT34X
--- linux-2.4.24/MAINTAINERS	2005-08-05 09:04:25.344454112 -0600
+++ linux-2.4.24.new/MAINTAINERS	2005-08-05 09:02:15.000000000 -0600
@@ -222,6 +222,13 @@
 W:      http://www.arm.linux.org.uk/
 S:	Maintained
 
+AMD GEODE/CS5535 PROCESSOR SUPPORT
+P:      
+M:
+L:
+W:
+S:    	Supported 
+
 APM DRIVER
 P:	Stephen Rothwell
 M:	sfr@canb.auug.org.au
--- linux-2.4.24/ChangeLog	1969-12-31 17:00:00.000000000 -0700
+++ linux-2.4.24.new/ChangeLog	2005-08-05 09:02:14.000000000 -0600
@@ -0,0 +1,63 @@
+--- linux-2.4.24-castle-1.02.0102 (08/02/05) ---
+
+r8169.patch:
+* Patch for RealTek 8169 driver for balista
+* backport patch for linux 2.4.27 kernel, attached to
+* https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=118637
+* tested on morelins/xstress, fixes hang + adds suspend/resume support
+
+--- linux-2.4.24-castle-1.02.02-pre1 TBD ---
+
+Update all patches with correct copyright information from Ray
+
+usb.patch:
+* Add Ray's gcc340 patch (drivers/usb/gadget/amd5536udc.c)
+
+--- linux-2.4.24-castle-1.02.01 5/20/05 ---
+
+No changes from -pre2
+
+--- linux-2.4.24-castle-1.02.01-pre2 ---
+
+castle-base.patch:
+* Update default configuration to include OTG (arch/i386/defconfig)
+* Add Documentation/geode.txt 
+* Modify A0 IDE driver so it co-exists (drivers/ide/pci/cs5535.c)
+* Add B0 IDE driver modifications (drivers/ide/pci/amd74xx.[ch])
+* remove drivers/usb/hcd.c from the patch
+
+usb.patch:
+* Add Hidensee UDC and OTG patches
+
+cimarron.patch:
+* Update to Cimarron 3.1.1
+
+kfb.patch:
+* Update Cimarron symbol (drivers/video/amd_fb.c)
+
+--- linux-2.4.24-castle-1.02.01-pre1 (04/27/05) ---
+
+cimarron.patch:
+* Update to Cimarron 3.0.3
+
+--- linux-2.4.24-castle-1.01.0401 (03/30/05) ---
+
+gx-base.patch (from linux-2.4.24-gx-1.1.2):
+* Update IDE timings for 5545 (drivers/ide/pci/cs5535.c)
+* Add update logic for APM blank (arch/i386/kernel/apm.c)
+* Remove extranious DPRINK (drivers/ide/pci/cs5535.c)
+
+castle-base.patch
+* Updated version number to 1.1.4 (Makefile)
+* added Bill's kcore fix (fs/kcore.c)
+
+cimarron.patch 
+* Updated to Cimarron 3.0
+* Pull 2.0 SWAPSiF defines (lib/cimarron/Makefile)
+
+kfb.patch:
+* Change Cimarron constant (drivers/video/geode/amd_fb.c)
+* Pull 2.0 SWAPSiF defines (drivers/video/geode/Makefile)
+* Allow user to change dflt panel settings (drivers/video/geode/amd_gx3_fb.c)
+* Remeber panning offsets (drivers/video/geode/amd_gx3_fb.c) 
+
--- linux-2.4.24/include/linux/pci_ids.h	2005-08-05 09:04:25.383448184 -0600
+++ linux-2.4.24.new/include/linux/pci_ids.h	2005-08-05 09:02:58.000000000 -0600
@@ -346,6 +346,13 @@
 #define PCI_DEVICE_ID_NS_SCx200_XBUS	0x0505
 #define PCI_DEVICE_ID_NS_87410		0xd001
 
+#define PCI_DEVICE_ID_NS_CS5535_HOST_BRIDGE  0x0028
+#define PCI_DEVICE_ID_NS_CS5535_ISA_BRIDGE   0x002b
+#define PCI_DEVICE_ID_NS_CS5535_IDE          0x002d
+#define PCI_DEVICE_ID_NS_CS5535_AUDIO        0x002e
+#define PCI_DEVICE_ID_NS_CS5535_USB          0x002f
+#define PCI_DEVICE_ID_NS_CS5535_VIDEO        0x0030
+
 #define PCI_VENDOR_ID_TSENG		0x100c
 #define PCI_DEVICE_ID_TSENG_W32P_2	0x3202
 #define PCI_DEVICE_ID_TSENG_W32P_b	0x3205
@@ -458,6 +465,17 @@
 #define PCI_DEVICE_ID_AMD_8111_AC97    0x746d
 #define PCI_DEVICE_ID_AMD_8131_APIC     0x7450
 
+#define PCI_DEVICE_ID_AMD_CASTLE_AES        0x2082
+
+#define PCI_DEVICE_ID_AMD_CS5536_ISA    0x2090
+#define PCI_DEVICE_ID_AMD_CS5536_FLASH  0x2091
+#define PCI_DEVICE_ID_AMD_CS5536_AUDIO  0x2093
+#define PCI_DEVICE_ID_AMD_CS5536_OHC    0x2094
+#define PCI_DEVICE_ID_AMD_CS5536_EHC    0x2095
+#define PCI_DEVICE_ID_AMD_CS5536_UDC    0x2096
+#define PCI_DEVICE_ID_AMD_CS5536_UOC    0x2097
+#define PCI_DEVICE_ID_AMD_CS5536_IDE    0x209A
+
 #define PCI_VENDOR_ID_TRIDENT		0x1023
 #define PCI_DEVICE_ID_TRIDENT_4DWAVE_DX	0x2000
 #define PCI_DEVICE_ID_TRIDENT_4DWAVE_NX	0x2001
--- linux-2.4.24/include/asm-i386/msr.h	2005-08-05 09:04:25.432440736 -0600
+++ linux-2.4.24.new/include/asm-i386/msr.h	2005-08-05 09:02:49.000000000 -0600
@@ -1,6 +1,8 @@
 #ifndef __ASM_MSR_H
 #define __ASM_MSR_H
 
+#include <linux/config.h>
+
 /*
  * Access to machine-specific registers (available on 586 and better only)
  * Note: the rd* operations modify the parameters directly (without using
@@ -17,8 +19,14 @@
 			  : /* no outputs */ \
 			  : "c" (msr), "a" (val1), "d" (val2))
 
+#ifdef CONFIG_GEODE_SC1200
+#define rdtsc(low,high) \
+     __asm__ __volatile__("rdtsc" : "=a" (low), "=d" (high)); \
+    if ((unsigned long) low > 0xFFFFFFFC) high--
+#else
 #define rdtsc(low,high) \
      __asm__ __volatile__("rdtsc" : "=a" (low), "=d" (high))
+#endif
 
 #define rdtscl(low) \
      __asm__ __volatile__("rdtsc" : "=a" (low) : : "edx")
