diff -urNp linux-7010/include/linux/brlock.h linux-7020/include/linux/brlock.h
--- linux-7010/include/linux/brlock.h
+++ linux-7020/include/linux/brlock.h
@@ -205,7 +206,7 @@ static inline void br_write_unlock (enum
 	do { local_bh_disable(); br_write_lock(idx); } while (0)
 
 #define br_read_unlock_irqrestore(idx, flags) \
-	do { br_read_unlock(irx); local_irq_restore(flags); } while (0)
+	do { br_read_unlock(idx); local_irq_restore(flags); } while (0)
 
 #define br_read_unlock_irq(idx) \
 	do { br_read_unlock(idx); local_irq_enable(); } while (0)
@@ -214,7 +215,7 @@ static inline void br_write_unlock (enum
 	do { br_read_unlock(idx); local_bh_enable(); } while (0)
 
 #define br_write_unlock_irqrestore(idx, flags) \
-	do { br_write_unlock(irx); local_irq_restore(flags); } while (0)
+	do { br_write_unlock(idx); local_irq_restore(flags); } while (0)
 
 #define br_write_unlock_irq(idx) \
 	do { br_write_unlock(idx); local_irq_enable(); } while (0)
--- linux/arch/i386/kernel/time.c.orig	2006-04-02 18:43:17.000000000 +0200
+++ linux/arch/i386/kernel/time.c	2006-04-02 18:41:30.000000000 +0200
@@ -910,7 +910,7 @@ time_cpufreq_notifier(struct notifier_bl
 		ref_freq = freq->old;
 		loops_per_jiffy_ref = cpu_data[freq->cpu].loops_per_jiffy;
 #ifndef CONFIG_SMP
-		fast_gettimeoffset_ref = fast_gettimeoffset_quotient;
+		fast_gettimeoffset_ref = (1 << 4) * scaled_nano_quotient;
 		cpu_khz_ref = cpu_khz;
 #endif
 	}
@@ -935,7 +935,8 @@ time_cpufreq_notifier(struct notifier_bl
 static struct notifier_block time_cpufreq_notifier_block = {
 	.notifier_call	= time_cpufreq_notifier
 };
-#endif
+#endif /* CONFIG_CPU_FREQ */
+#endif /* CONFIG_X86_TSC */
 
 
 void __init time_init(void)
--- linux-2.4.21/drivers/audit/syscall.c.orig	2006-04-02 20:45:56.000000000 +0200
+++ linux-2.4.21/drivers/audit/syscall.c	2006-04-02 20:48:52.000000000 +0200
@@ -29,6 +29,7 @@
 #include <linux/sys.h>
 #include <linux/utsname.h>
 #include <linux/utime.h>
+#include <linux/timex.h>
 #include <linux/sysctl.h>
 #include <linux/sockios.h>
 #include <linux/if.h>
